ViewVC Help
View File | Revision Log | Show Annotations | Download File
/cvs/deliantra/server/utils/cfutil.in
(Generate patch)

Comparing deliantra/server/utils/cfutil.in (file contents):
Revision 1.21 by root, Thu Apr 5 12:34:31 2007 UTC vs.
Revision 1.50 by root, Thu Aug 9 22:54:28 2007 UTC

6my $exec_prefix = "@exec_prefix@"; 6my $exec_prefix = "@exec_prefix@";
7my $datarootdir = "@datarootdir@"; 7my $datarootdir = "@datarootdir@";
8my $DATADIR = "@datadir@/@PACKAGE@"; 8my $DATADIR = "@datadir@/@PACKAGE@";
9 9
10my $CONVERT = "@CONVERT@"; 10my $CONVERT = "@CONVERT@";
11my $IDENTIFY = "@IDENTIFY@"; 11#my $IDENTIFY = "@IDENTIFY@";
12my $OPTIPNG = "@OPTIPNG@"; 12my $OPTIPNG = "@OPTIPNG@";
13my $RSYNC = "@RSYNC@"; 13my $RSYNC = "@RSYNC@";
14my $PNGNQ = "@PNGNQ@";
14 15
15use Getopt::Long; 16use Getopt::Long;
16use Coro::Event; 17use Coro::Event;
17use AnyEvent; 18use AnyEvent;
18use IO::AIO (); 19use IO::AIO ();
20use Crossfire; 21use Crossfire;
21use Coro; 22use Coro;
22use Coro::AIO; 23use Coro::AIO;
23use POSIX (); 24use POSIX ();
24use Digest::MD5; 25use Digest::MD5;
26use Carp;
25use Storable; $Storable::canonical = 1; 27use Coro::Storable; $Storable::canonical = 1;
28
29$SIG{QUIT} = sub { Carp::cluck "QUIT" };
26 30
27sub usage { 31sub usage {
28 warn <<EOF; 32 warn <<EOF;
29Usage: cfutil [-v] [-q] [--force] [--cache] 33Usage: cfutil [-v] [-q] [--force] [--cache]
30 [--install-arch path] 34 [--install-arch path]
42my $CACHE = 0; 46my $CACHE = 0;
43my $FORCE; 47my $FORCE;
44my $TMPDIR = "/tmp/cfutil$$~"; 48my $TMPDIR = "/tmp/cfutil$$~";
45my $TMPFILE = "aaaa0"; 49my $TMPFILE = "aaaa0";
46 50
51our %COLOR = (
52 black => 0,
53 white => 1,
54 navy => 2,
55 red => 3,
56 orange => 4,
57 blue => 5,
58 darkorange => 6,
59 green => 7,
60 lightgreen => 8,
61 grey => 9,
62 brown => 10,
63 gold => 11,
64 tan => 12,
65);
66
47END { system "rm", "-rf", $TMPDIR } 67END { system "rm", "-rf", $TMPDIR }
48 68
49Event->signal (signal => "INT", cb => sub { exit 1 }); 69Event->signal (signal => "INT", cb => sub { exit 1 });
50Event->signal (signal => "TERM", cb => sub { exit 1 }); 70Event->signal (signal => "TERM", cb => sub { exit 1 });
51 71
68} 88}
69 89
70sub inst_maps($) { 90sub inst_maps($) {
71 my (undef, $path) = @_; 91 my (undef, $path) = @_;
72 92
73 print "installing '$path' to '$DATADIR/maps'\n"; 93 print "\nInstalling '$path' to '$DATADIR/maps'\n\n";
74 94
75 if (!-f "$path/regions") { 95 if (!-f "$path/regions") {
76 warn "'$path' does not look like a maps directory ('regions' file is missing).\n"; 96 warn "'$path' does not look like a maps directory ('regions' file is missing).\n";
77 exit 1 unless $FORCE; 97 exit 1 unless $FORCE;
78 } 98 }
79 99
80 system $RSYNC, "-av", "$path/.", "$DATADIR/maps/.", "--delete", "--exclude", "CVS", "--delete-excluded" 100 system $RSYNC, "-a", "--chmod=u=rwX,go=rX", "$path/.", "$DATADIR/maps/.", "--delete", "--exclude", "CVS", "--delete-excluded"
81 and die "map installation failed.\n"; 101 and die "map installation failed.\n";
82 102
83 print "maps installed successfully.\n"; 103 print "maps installed successfully.\n";
84} 104}
85 105
86{ 106{
107 our %ANIMINFO;
87 our %FACEINFO; 108 our %FACEINFO;
109 our %RESOURCE;
88 our @ARC; 110 our @ARC;
111 our %ARC;
89 our $TRS; 112 our $TRS;
90 our $NFILE; 113 our $NFILE;
91 our %ANIM; 114 our $PATH;
92 115
93 our $QUANTIZE = "+dither -colorspace RGB -colors 256"; 116 our $QUANTIZE = "+dither -colorspace RGB -colors 256";
94 117
95 our (@png, @trs, @arc); # files we are interested in 118 our (@png, @trs, @arc, @res); # files we are interested in
96 119
97 sub commit_png($$$) { 120 sub commit_png($$$) {
98 my ($name, $data, $T) = @_; 121 my ($name, $data, $T) = @_;
99 122
100 $FACEINFO{$name}{"data$T"} = $data; 123 $FACEINFO{$name}{"data$T"} = $data;
147 # possibly enlarge 170 # possibly enlarge
148 if (0 > aio_stat "$stem.64x64.png") { 171 if (0 > aio_stat "$stem.64x64.png") {
149 my $other = "$stem.64x64.png~"; 172 my $other = "$stem.64x64.png~";
150 173
151 if (0 > aio_lstat $other or (-M _) > (-M $path)) { 174 if (0 > aio_lstat $other or (-M _) > (-M $path)) {
152 warn "rescale $other\n";#d#
153 my $wrap = 0; # for the time being 175 my $wrap = 0; # for the time being
154 fork_sub { 176 fork_sub {
155 system "convert png:\Q$path\E -depth 8 rgba:-" 177 system "convert png:\Q$path\E -depth 8 rgba:-"
156 . "| $exec_prefix/bin/cfhq2xa $w $h $wrap" 178 . "| $exec_prefix/bin/cfhq2xa $w $h $wrap"
157 . "| convert -depth 8 -size ".($w * 2)."x".($h * 2)." rgba:- $QUANTIZE -quality 00 png32:\Q$other\E~" 179 . "| convert -depth 8 -size ".($w * 2)."x".($h * 2)." rgba:- $QUANTIZE -quality 00 png32:\Q$other\E~"
158 and die "convert/hq2xa pipeline error: status $? ($!)"; 180 and die "convert/hq2xa pipeline error: status $? ($!)";
159 system $OPTIPNG, "-o5", "-i0", "-q", "$other~"; 181 system $OPTIPNG, "-i0", "-q", "$other~";
160 die "$other~ has zero size, aborting." unless -s "$other~"; 182 die "$other~ has zero size, aborting." unless -s "$other~";
161 rename "$other~", $other; 183 rename "$other~", $other;
162 }; 184 };
163 } 185 }
164 186
170 my $other = "$stem.32x32.png~"; 192 my $other = "$stem.32x32.png~";
171 193
172 if (0 > aio_lstat $other or (-M _) > (-M $path)) { 194 if (0 > aio_lstat $other or (-M _) > (-M $path)) {
173 fork_sub { 195 fork_sub {
174 system "convert png:\Q$path\E -geometry 50% -filter lanczos $QUANTIZE -quality 00 png32:\Q$other\E~"; 196 system "convert png:\Q$path\E -geometry 50% -filter lanczos $QUANTIZE -quality 00 png32:\Q$other\E~";
175 system $OPTIPNG, "-o5", "-i0", "-q", "$other~"; 197 system $OPTIPNG, "-i0", "-q", "$other~";
198
199 # reduce smoothfaces >10000 bytes
200 if ($stem =~ /_S\./ && (-s "$other~") > 10000) {
201 my $ncolor = 256;
202 while () {
203 system "<\Q$other~\E $PNGNQ -s1 -n$ncolor >\Q$other~~\E";
204 system $OPTIPNG, "-i0", "-q", "$other~~";
205 last if 10000 > -s "$other~~";
206 $ncolor = int $ncolor * 0.9;
207 $ncolor > 8 or die "cannot reduce filesize to < 10000 bytes";
208 }
209
210 printf "reduced %s from %d to %d bytes using %d colours.\n",
211 $other, -s "$other~", -s "$other~~", $ncolor
212 if $VERBOSE >= 2;
213 rename "$other~~", "$other~";
214 }
215
176 die "$other~ has zero size, aborting." unless -s "$other~"; 216 die "$other~ has zero size, aborting." unless -s "$other~";
177 rename "$other~", $other; 217 rename "$other~", $other;
178 }; 218 };
179 } 219 }
180 220
183 } 223 }
184 } 224 }
185 225
186 (my $face = $stem) =~ s/^.*\///; 226 (my $face = $stem) =~ s/^.*\///;
187 227
228 # split all bigfaces, but avoid smoothfaces (*_S)
188 if (($w > $T || $h > $T) && $face !~ /_S\./) { 229 if (($w > $T || $h > $T) && $face !~ /_S\./) {
189 # split 230 # split
190 my @tile; 231 my @tile;
191 for my $x (0 .. (int $w / $T) - 1) { 232 for my $x (0 .. (int $w / $T) - 1) {
192 for my $y (0 .. (int $h / $T) - 1) { 233 for my $y (0 .. (int $h / $T) - 1) {
256 aio_load "$dir/$file", $arc; # simply pre-cache, as read_arch wants a file :/ 297 aio_load "$dir/$file", $arc; # simply pre-cache, as read_arch wants a file :/
257 298
258 my $arc = read_arch "$dir/$file"; 299 my $arc = read_arch "$dir/$file";
259 for my $o (values %$arc) { 300 for my $o (values %$arc) {
260 push @ARC, $o; 301 push @ARC, $o;
302 for (my $m = $o; $m; $m = $m->{more}) {
303 $ARC{$m->{_name}} = $m;
304 }
261 305
262 $o->{editor_folder} = $dir; 306 $o->{editor_folder} = $dir;
263 307
264 my $visibility = delete $o->{visibility}; 308 my $visibility = delete $o->{visibility};
265 my $magicmap = delete $o->{magicmap}; 309 my $magicmap = delete $o->{magicmap};
276 my $x = $o->{x} - $dx; 320 my $x = $o->{x} - $dx;
277 my $y = $o->{y} - $dy; 321 my $y = $o->{y} - $dy;
278 322
279 my $ext = $x|$y ? "+$x+$y" : ""; 323 my $ext = $x|$y ? "+$x+$y" : "";
280 324
281 $o->{face} .= $ext unless /^blank.x11$|^empty.x11$/; 325 $o->{face} .= $ext unless /^blank.x11$|^empty.x11$/ || !$o->{face};
282 326
283 my $visibility = delete $o->{visibility} if exists $o->{visibility}; 327 $visibility = delete $o->{visibility} if exists $o->{visibility};
284 my $magicmap = delete $o->{magicmap} if exists $o->{magicmap}; 328 $magicmap = delete $o->{magicmap} if exists $o->{magicmap};
285 329
286 my $anim = delete $o->{anim}; 330 my $anim = delete $o->{anim};
287 331
288 if ($anim) { 332 if ($anim) {
333 # possibly add $ext to the animation name to avoid
334 # the need to specify archnames for all parts
335 # of a multipart archetype.
289 $o->{animation} = "$o->{_name}"; 336 $o->{animation} = "$o->{_name}";
337 my $facings = 1;
338 my @frames;
290 339
291 for (@$anim) { 340 for (@$anim) {
292 $_ .= $ext unless /^facings\s|^blank.x11$|^empty.x11$/; 341 if (/^facings\s+(\d+)/) {
342 $facings = $1*1;
343 } elsif (/^blank.x11$|^empty.x11$/) {
344 push @frames, $_;
345 } else {
346 push @frames, "$_$ext";
347 }
293 } 348 }
294 349
295 $ANIM{"$o->{_name}$ext"} = 350 $ANIMINFO{$o->{animation}} = {
296 join "", map "$_\n", 351 facings => $facings,
297 "anim $o->{_name}", 352 frames => \@frames,
298 @$anim, 353 };
299 "mina";
300 } 354 }
301 355
302 for my $face ($o->{face} || (), @{$anim || []}) { 356 for my $face ($o->{face} || (), @{$anim || []}) {
303 next if $face =~ /^facings\s|^blank.x11$|^empty.x11$/; 357 next if $face =~ /^facings\s|^blank.x11$|^empty.x11$/;
304 358
307 $info->{visibility} = $visibility if defined $visibility; 361 $info->{visibility} = $visibility if defined $visibility;
308 $info->{magicmap} = $magicmap if defined $magicmap; 362 $info->{magicmap} = $magicmap if defined $magicmap;
309 } 363 }
310 364
311 if (my $smooth = delete $o->{smoothface}) { 365 if (my $smooth = delete $o->{smoothface}) {
312 my ($face, $smooth) = split /\s+/, $smooth; 366 my %kv =split /\s+/, $smooth;
313 # skip empty_S.x11, it seems to server no purpose whatsoever 367 my $level = $o->{smoothlevel}; #TODO: delete from $o if !gcfclient-support
314 # but increases bandwidth demands and worse. 368 while (my ($face, $smooth) = each %kv) {
315 unless ($smooth eq "empty_S.x11") {
316 $FACEINFO{$face}{smooth} = $smooth; 369 $FACEINFO{$face}{smooth} = $smooth;
370 $FACEINFO{$face}{smoothlevel} = $level;
317 } 371 }
318 } 372 }
319 } 373 }
320 } 374 }
321 } 375 }
334 388
335 $TRS .= $trs; 389 $TRS .= $trs;
336 } 390 }
337 } 391 }
338 392
393 my %FILECACHE;
394
395 sub load_cached($;$) {
396 unless (exists $FILECACHE{$_[0]}) {
397 my $data;
398 if (0 < aio_load $_[0], $data) {
399 if ($_[1]) {
400 $data = eval { $_[1]->($data) };
401 warn "$_[0]: $@" if $@;
402 }
403 }
404
405 $FILECACHE{$_[0]} = $data;
406 }
407
408 $FILECACHE{$_[0]}
409 }
410
411 sub process_res {
412 while (@res) {
413 my ($dir, $file, $type) = @{pop @res};
414
415 my $data;
416 aio_load "$dir/$file", $data;
417
418 my $meta = load_cached "$dir/meta", sub { JSON::XS::from_json shift };
419
420 next if $meta && !exists $meta->{$file};
421
422 $meta = {
423 %{ $meta->{"" } || {} },
424 %{ $meta->{$file} || {} },
425 };
426
427 if ($meta->{license} =~ s/^#//) {
428 $meta->{license} = ({
429 "pd" => "Public Domain",
430 "gpl" => "GNU General Public License, version 3.0 or any later",
431 "cc/by/2.0" => "Licensed under Creative Commons Attribution 2.0 http://creativecommons.org/licenses/by/2.0/",
432 "cc/by/2.5" => "Licensed under Creative Commons Attribution 2.0 http://creativecommons.org/licenses/by/2.5/",
433 "cc/by/3.0" => "Licensed under Creative Commons Attribution 3.0 http://creativecommons.org/licenses/by/3.0/",
434 })->{$meta->{license}}
435 || warn "$dir/$file: license tag '$meta->{license}' not found.";
436 }
437
438 $file =~ s/\.res$//;
439 $file =~ s/\.(ogg|wav|jpg|png)$//;
440
441 substr $dir, 0, 1 + length $PATH, "";
442
443 $RESOURCE{"$dir/$file"} = {
444 type => (delete $meta->{type}) || $type,
445 data => $data,
446 chksum => (Digest::MD5::md5 $data),
447 %$meta ? (meta => $meta) : (),
448 };
449 }
450 }
451
339 sub find_files; 452 sub find_files;
340 sub find_files { 453 sub find_files {
341 my ($path) = @_; 454 my ($path) = @_;
342 455
343 IO::AIO::aioreq_pri 4; 456 IO::AIO::aioreq_pri 4;
345 my ($dirs, $nondirs) = @_; 458 my ($dirs, $nondirs) = @_;
346 459
347 find_files "$path/$_" 460 find_files "$path/$_"
348 for grep $_ !~ /^(?:CVS|dev)$/, @$dirs; 461 for grep $_ !~ /^(?:CVS|dev)$/, @$dirs;
349 462
463 my $dir = $path;
464 substr $dir, 0, 1 + length $PATH, "";
465
350 for my $file (@$nondirs) { 466 for my $file (@$nondirs) {
467 if ($dir =~ /^music(?:\/|$)/) {
468 push @res, [$path, $file, 3] # FT_MUSIC
469 if $file =~ /\.(ogg)$/;
470
471 } elsif ($dir =~ /^sound(?:\/|$)/) {
472 push @res, [$path, $file, 5] # FT_SOUND
473 if $file =~ /\.(wav|ogg)$/;
474
475 } elsif ($dir =~ /^res(?:\/|$)/) {
476 push @res, [$path, $file, 0] # FT_FACE
477 if $file =~ /\.(jpg|png)$/;
478 push @res, [$path, $file, 7] # FT_RSRC
479 if $file =~ /\.(res)$/;
480
351 if ($file =~ /\.png$/) { 481 } elsif ($file =~ /\.png$/) {
352 push @png, ["$path/$file", 0]; 482 push @png, ["$path/$file", 0];
483
353 } elsif ($file =~ /\.trs$/) { 484 } elsif ($file =~ /\.trs$/) {
354 push @trs, [$path, $file]; 485 push @trs, [$path, $file];
486
355 } elsif ($file =~ /\.arc$/) { 487 } elsif ($file =~ /\.arc$/) {
356 push @arc, [$path, $file]; 488 push @arc, [$path, $file];
489
357 } else { 490 } else {
358 warn "ignoring $path/$file\n" if $VERBOSE >= 2; 491 warn "ignoring $path/$file\n" if $VERBOSE >= 3;
359 } 492 }
360 } 493 }
361 }; 494 };
362 } 495 }
363 496
364 sub inst_arch($) { 497 sub inst_arch($) {
365 my (undef, $path) = @_; 498 my (undef, $path) = @_;
366 499
500 $PATH = $path;
501
502 print "\n",
367 print "installing '$path' to '$DATADIR'\n", 503 "Installing '$path' to '$DATADIR'\n",
504 "\n",
368 "(this can take a long time if you run this\n", 505 "This can take a long time if you run this\n",
369 "for the first time or do not use --cache).\n"; 506 "for the first time or do not use --cache.\n",
507 "\n",
508 "Unless you run verbosely, all following warning\n",
509 "or error messages indicate serious problems.\n",
510 "\n";
370 511
371 if (!-d "$path/treasures") { 512 if (!-d "$path/treasures") {
372 warn "'$path' does not look like an arch directory ('treasures' directory is missing).\n"; 513 warn "'$path' does not look like an arch directory ('treasures' directory is missing).\n";
373 exit 1 unless $FORCE; 514 exit 1 unless $FORCE;
374 } 515 }
379 $_->join for ( 520 $_->join for (
380 # four png crunchers work fine for my 2x smp machine 521 # four png crunchers work fine for my 2x smp machine
381 (async \&process_png), (async \&process_png), (async \&process_png), (async \&process_png), 522 (async \&process_png), (async \&process_png), (async \&process_png), (async \&process_png),
382 (async \&process_trs), (async \&process_trs), 523 (async \&process_trs), (async \&process_trs),
383 (async \&process_arc), (async \&process_arc), 524 (async \&process_arc), (async \&process_arc),
525 (async \&process_res), (async \&process_res),
384 ); 526 );
385 527
386 { 528 {
387 open my $fh, ">:utf8", "$DATADIR/animations~" 529 # remove path prefix from editor_folder
388 or die "$DATADIR/animations~: $!"; 530 substr $_->{editor_folder}, 0, 1 + length $path, ""
389 print $fh join "", map $ANIM{$_}, sort keys %ANIM 531 for values %ARC;
532
533 # resolve inherit
534 while () {
535 my $progress;
536 my $loop;
537
538 for my $o (values %ARC) {
539 if (my $other = $o->{inherit}) {
540 if (my $s = $ARC{$other}) {
541 if ($s->{inherit}) {
542 $loop = $s;
543 } else {
544 delete $o->{inherit};
545 my %s = %$s;
546 delete @s{qw(_name more name name_pl)};
547 %$o = ( %s, %$o );
548 ++$progress;
549 }
550 } else {
551 warn "'$o->{_name}' tries to inherit from undefined archetype '$other', skipping.\n";
552 delete $ARC{$o->{_name}};
553 }
554 }
555 }
556
557 unless ($progress) {
558 die "inheritance loop detected starting at archetype '$loop->{_name}', aborting.\n"
559 if $loop;
560
561 last;
562 }
390 } 563 }
391 564
392 { 565 # remove base classes (by naming scheme, should use something like "baseclass xxx" to inherit
566 @ARC = grep $_->{_name} !~ /^(?:type|class)_/, @ARC;
567
393 open my $fh, ">:utf8", "$DATADIR/archetypes~" 568 open my $fh, ">:utf8", "$DATADIR/archetypes~"
394 or die "$DATADIR/archetypes~: $!"; 569 or die "$DATADIR/archetypes~: $!";
395 substr $_->{editor_folder}, 0, 1 + length $path, "" for @ARC; 570 print $fh Crossfire::archlist_to_string [sort { $a->{_name} cmp $b->{_name} } @ARC];
396 print $fh Crossfire::archlist_to_string \@ARC;
397 } 571 }
398 572
399 { 573 {
400 open my $fh, ">:utf8", "$DATADIR/treasures~" 574 open my $fh, ">:utf8", "$DATADIR/treasures~"
401 or die "$DATADIR/treasures~: $!"; 575 or die "$DATADIR/treasures~: $!";
410 length $v->{data32} <= 10000 or warn "$k: face32 larger than 10000 bytes, will not work with crossfire client.\n"; 584 length $v->{data32} <= 10000 or warn "$k: face32 larger than 10000 bytes, will not work with crossfire client.\n";
411 #length $v->{data64} <= 10000 or warn "$k: face64 larger than 10000 bytes.\n"; 585 #length $v->{data64} <= 10000 or warn "$k: face64 larger than 10000 bytes.\n";
412 586
413 $v->{chksum32} = Digest::MD5::md5 $v->{data32}; 587 $v->{chksum32} = Digest::MD5::md5 $v->{data32};
414 $v->{chksum64} = Digest::MD5::md5 $v->{data64}; 588 $v->{chksum64} = Digest::MD5::md5 $v->{data64};
589
590 if (my $magicmap = $v->{magicmap}) {
591 $magicmap =~ y/A-Z_\-/a-z/d;
592 $v->{magicmap} = $COLOR{$magicmap};
593 }
415 } 594 }
416 595
417 open my $fh, ">:perlio", "$DATADIR/facedata~" 596 open my $fh, ">:perlio", "$DATADIR/facedata~"
418 or die "$DATADIR/facedata~: $!"; 597 or die "$DATADIR/facedata~: $!";
419 598
420 $FACEINFO{""} = { version => 1}; 599 print $fh freeze {
421 print $fh Storable::nfreeze \%FACEINFO; 600 version => 2,
601 faceinfo => \%FACEINFO,
602 animinfo => \%ANIMINFO,
603 resource => \%RESOURCE,
422 } 604 };
605 }
423 606
424 for (qw(archetypes facedata animations treasures)) { 607 for (qw(archetypes facedata treasures)) {
425 chmod 0644, "$DATADIR/$_~"; 608 chmod 0644, "$DATADIR/$_~";
426 rename "$DATADIR/$_~", "$DATADIR/$_" 609 rename "$DATADIR/$_~", "$DATADIR/$_"
427 or die "$DATADIR/$_: $!"; 610 or die "$DATADIR/$_: $!";
428 } 611 }
429 612

Diff Legend

Removed lines
+ Added lines
< Changed lines
> Changed lines